import { Component, OnInit, Input, OnDestroy } from '@angular/core';
import { User } from '../models/user.model';
import { UsersService } from '../services/users.service';
import { ActivatedRoute } from '@angular/router';
import { Subscription } from 'rxjs';

import {switchMap} from "rxjs/operators";


@Component({
  selector: 'app-user',
  templateUrl: './user.component.html',
  styleUrls: ['./user.component.sass'],
})
export class UserComponent implements OnInit, OnDestroy {

  @Input('myUser') user: User;
  @Input('ind') ind: number;

  id: number;
  
  private subsc: Subscription;
  constructor(private activateRoute: ActivatedRoute, private userService: UsersService) { 
      //this.subsc = activateRoute.params.subscribe(params => this.id = params['nmb']);


      this.subsc = activateRoute.paramMap.pipe(switchMap(params => params.getAll('nmb'))).subscribe(params => this.id = parseInt(params));


  }

  ngOnInit(): void {
    if(!this.user) {
      this.user = this.userService.getUser(this.id);
    }
  }

  ngOnDestroy() {
    console.log('ngOnDestroy');
    this.subsc = null;
  }

  

}
